﻿using System;
using System.Linq;

using IdeaBlade.EntityModel;
using IdeaBlade.Core;

namespace DomainModel {

  public class DynamicInterceptors {

    public static void AddDynamicEntityInterceptors() {

      // Add dynamic actions on Entity to affect any property on any Entity sub-type.

      PropertyInterceptorManager.CurrentInstance.AddAction(
        new PropertyInterceptorAction<PropertyInterceptorArgs<Entity, Object>>(
          typeof(Entity),
          null,
          PropertyInterceptorMode.BeforeSet,
          (args) => System.Diagnostics.Debug.WriteLine("Entity BeforeSet"),
          0.0, "A"));

      PropertyInterceptorManager.CurrentInstance.AddAction(
        new PropertyInterceptorAction<PropertyInterceptorArgs<Entity, Object>>(
          typeof(Entity),
          null,
          PropertyInterceptorMode.AfterSet,
          (args) => System.Diagnostics.Debug.WriteLine("Entity AfterSet"),
          0.0, "B"));

    }

  }
}