﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Windows.Controls;

using DomainModel;
using IdeaBlade.EntityModel;
using System.Collections.ObjectModel;

namespace LiteHausWPF {
    /// <summary>
    /// Interaction logic for CustomersUserControl.xaml
    /// </summary>
    public partial class CustomersUserControl {
        public CustomersUserControl() {
            this.InitializeComponent();
            ConfigureCustomerSelectorListBox();
        }

        private void ConfigureCustomerSelectorListBox() {
            _selectCustomerListBox.DisplayMemberPath = Customer.PathFor(e => e.CompanyName);
        }

        public void LoadSupportingData() {
        }

        public void LoadData() {
            _customers = new ObservableCollection<Customer>(
                _mgr.Customers.OrderBy(c=>c.CompanyName));
            _selectCustomerListBox.ItemsSource = _customers;
            this.DataContext = _customers;
        }

        #region Private Fields
        NorthwindIBEntities _mgr = new NorthwindIBEntities();
        ObservableCollection<Customer> _customers;
        #endregion Private Fields

    }
}