﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.Windows;
using System.Windows.Controls;
//using System.Windows.Data;
//using System.Windows.Documents;
//using System.Windows.Input;
using System.Windows.Media;
//using System.Windows.Media.Imaging;
//using System.Windows.Shapes;

using DomainModel;
using System.Collections.ObjectModel;

namespace LiteHausWPF {
    class EmployeeTabItem : TabItemBase {

        public EmployeeTabItem() {
            InitEmployeeTabItem();
            ConfigureEventHandlers();
        }

        private void ConfigureEventHandlers() {
            _anEmployeesUserControl._selectEmployeeListBox.SelectionChanged += new SelectionChangedEventHandler(_selectEmployeeListBox_SelectionChanged);
        }

        void _selectEmployeeListBox_SelectionChanged(object sender, SelectionChangedEventArgs e) {
            //ListBox selectionListBox = (ListBox)sender;
            //Employee selectedEmployee = (Employee)selectionListBox.SelectedItem;
            _ordersForCurrentEmployee.Clear();
            foreach (Order anOrder in _anEmployeesUserControl.CurrentEmployee.Orders) {
                _ordersForCurrentEmployee.Add(anOrder);
            }
            _anOrdersUserControl.LoadMainData(_ordersForCurrentEmployee);
        }

        private void InitEmployeeTabItem() {
            this.Header = "Employees";
        }

        public override void LoadContent() {
            DockPanel aDockPanel = new DockPanel();
            this.Content = aDockPanel;

            aDockPanel.Children.Add(_anEmployeesUserControl);

            _anEmployeesUserControl.HorizontalAlignment = HorizontalAlignment.Stretch;
            _anEmployeesUserControl.VerticalAlignment = VerticalAlignment.Stretch;

            //_anOrdersUserControl._ordersDataGrid.ItemsSource=
            aDockPanel.Children.Add(_anOrdersUserControl);

            _anEmployeesUserControl.Padding = new Thickness(5);
            _anOrdersUserControl.Padding = new Thickness(10);

            DockPanel.SetDock(_anEmployeesUserControl, Dock.Top);
            DockPanel.SetDock(_anOrdersUserControl, Dock.Bottom);
        }

        public override void LoadData() {
            _anEmployeesUserControl.LoadSupportingData();
            _anEmployeesUserControl.LoadData();
            _anOrdersUserControl.LoadSupportingData();
        }

        #region private Fields
        EmployeesUserControl _anEmployeesUserControl = new EmployeesUserControl();
        OrdersUserControl _anOrdersUserControl = new OrdersUserControl();
        ObservableCollection<Order> _ordersForCurrentEmployee = new ObservableCollection<Order>();
        #endregion private Fields

    }
}
