﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Windows.Controls;

using DomainModel;
using IdeaBlade.EntityModel;
using System.Collections.ObjectModel;

namespace LiteHausWPF {
    /// <summary>
    /// Interaction logic for OrdersUserControl.xaml
    /// </summary>
    public partial class OrdersUserControl {
        public OrdersUserControl() {
            this.InitializeComponent();
            ConfigureOrderSelectorListBox();
        }

        private void ConfigureOrderSelectorListBox() {
            //_selectOrderListBox.DisplayMemberPath = Order.PathFor(e => e.CompanyName);
        }

        public void LoadData() {
            LoadSupportingData();
            LoadMainData();
        }

        public void LoadSupportingData() {
            _customers = new ObservableCollection<Customer>(
                _mgr.Customers.OrderBy(c => c.CompanyName));
            ConfigureDataGridComboBoxColumnForCustomer();
        }

        private void ConfigureDataGridComboBoxColumnForCustomer() {
            //DataGridComboBoxColumn dgCbCol = (DataGridComboBoxColumn)_ordersDataGrid.Columns[_indexOfCustomerColumn];
            //dgCbCol.ItemsSource = _customers;
            //dgCbCol.DisplayMemberPath = Customer.PathFor(c => c.CompanyName);

            CustomerColumn.ItemsSource = _customers;
            CustomerColumn.DisplayMemberPath = Customer.PathFor(c => c.CompanyName);
        }

        public void LoadMainData() {
            _orders = new ObservableCollection<Order>(
                _mgr.Orders.OrderBy(o => o.OrderDate));
            //_selectOrderListBox.ItemsSource = _Orders;
            this.DataContext = _orders;
            this._ordersDataGrid.ItemsSource = _orders;
        }

        public void LoadMainData(ObservableCollection<Order> orders) {
            _orders.Clear();
            foreach (Order anOrder in orders) {
                _orders.Add(anOrder);
            }
            this.DataContext = _orders;
            this._ordersDataGrid.ItemsSource = _orders;
        }

        #region Private Fields
        NorthwindIBEntities _mgr = new NorthwindIBEntities();
        ObservableCollection<Order> _orders = new ObservableCollection<Order>();
        ObservableCollection<Customer> _customers;
        const int _indexOfCustomerColumn = 1;
        #endregion Private Fields
    }
}