﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Microsoft.Windows.Controls;

using DomainModel;
using IdeaBlade.EntityModel;
using System.Collections.ObjectModel;

namespace LiteHausWPF {
    /// <summary>
    /// Interaction logic for CustomersUserControl.xaml
    /// </summary>
    public partial class ProductsUserControl {
        public ProductsUserControl() {
            this.InitializeComponent();
            ConfigureProductSelectorListBox();
        }

        private void ConfigureProductSelectorListBox() {
            _selectProductListBox.DisplayMemberPath = Product.PathFor(e => e.ProductName);
        }

        public void LoadSupportingData() {
        }

        public void LoadData() {
            _products = new ObservableCollection<Product>(
                _mgr.Products.OrderBy(c=>c.ProductName));
            _selectProductListBox.ItemsSource = _products;
            this.DataContext = _products;
        }

        #region Private Fields
        NorthwindIBEntities _mgr = new NorthwindIBEntities();
        ObservableCollection<Product> _products;
        #endregion Private Fields
    }
}