﻿Imports IdeaBlade.EntityModel
Imports IdeaBlade.Core

''' <summary>
''' The developer class representing the Employee business object.
''' </summary>
Partial Public Class Employee


    ' Add additional logic to your business object here...
#Region "Public Properties"

    ''' <summary>
    ''' LastName, FirstName
    ''' </summary>
    Public ReadOnly Property LastFirst() As String
        Get
            Dim aLastFirst As String = Me.LastName & ", " & Me.FirstName
            If aLastFirst = ", " Then
                aLastFirst = "(Not specified)"
            End If
            Return aLastFirst
        End Get
    End Property

    ''' <summary>
    ''' Age as of today
    ''' </summary>
    Public ReadOnly Property Age() As Integer
        Get
            If Nothing Is BirthDate Then
                Return 0
            End If
            Dim oBirthDate As Date = CDate(Me.BirthDate)
            Dim oToday As Date = Date.Today
            Dim oAge As Integer = oToday.Year - oBirthDate.Year
            If oBirthDate.AddYears(oAge) > oToday Then
                oAge -= 1
            End If
            If oAge < 0 Then
                Return 0
            Else
                Return oAge
            End If
        End Get
    End Property

    Public ReadOnly Property NumberOfOrders() As Integer
        Get
            Return Me.Orders.Count()
        End Get
    End Property

    ''' <summary>
    ''' Total revenue for this Employee's orders
    ''' </summary>
    Public ReadOnly Property TotalOrderRevenue() As Double
        Get
            Dim revenue As Double = 0
            For Each aOrder As Order In Me.Orders
                For Each aOrderDetail As OrderDetail In aOrder.OrderDetails
                    revenue += aOrderDetail.Quantity * Convert.ToDouble(aOrderDetail.UnitPrice) * aOrderDetail.Discount
                Next aOrderDetail
            Next aOrder
            Return revenue
        End Get
    End Property

#End Region

End Class

