﻿Imports System.Text


'using System.Windows.Data;
'using System.Windows.Documents;
'using System.Windows.Input;
'using System.Windows.Media.Imaging;
'using System.Windows.Shapes;

Imports DomainModel
Imports System.Collections.ObjectModel

Friend Class EmployeeTabItem
    Inherits TabItemBase

    Public Sub New()
        InitEmployeeTabItem()
        ConfigureEventHandlers()
    End Sub

    Private Sub ConfigureEventHandlers()
        AddHandler _anEmployeesUserControl._selectEmployeeListBox.SelectionChanged, AddressOf _selectEmployeeListBox_SelectionChanged
    End Sub

    Private Sub _selectEmployeeListBox_SelectionChanged(ByVal sender As Object, ByVal e As SelectionChangedEventArgs)
        'ListBox selectionListBox = (ListBox)sender;
        'Employee selectedEmployee = (Employee)selectionListBox.SelectedItem;
        _ordersForCurrentEmployee.Clear()
        For Each anOrder As Order In _anEmployeesUserControl.CurrentEmployee.Orders
            _ordersForCurrentEmployee.Add(anOrder)
        Next anOrder
        _anOrdersUserControl.LoadMainData(_ordersForCurrentEmployee)
    End Sub

    Private Sub InitEmployeeTabItem()
        Me.Header = "Employees"
    End Sub

    Public Overrides Sub LoadContent()
        Dim aDockPanel As New DockPanel()
        Me.Content = aDockPanel

        _anEmployeesUserControl = New EmployeesUserControl()
        aDockPanel.Children.Add(_anEmployeesUserControl)

        _anEmployeesUserControl.HorizontalAlignment = HorizontalAlignment.Stretch
        _anEmployeesUserControl.VerticalAlignment = VerticalAlignment.Stretch

        _anOrdersUserControl = New OrdersUserControl
        aDockPanel.Children.Add(_anOrdersUserControl)

        _anEmployeesUserControl.Padding = New Thickness(5)
        _anOrdersUserControl.Padding = New Thickness(10)

        DockPanel.SetDock(_anEmployeesUserControl, Dock.Top)
        DockPanel.SetDock(_anOrdersUserControl, Dock.Bottom)
    End Sub

    Public Overrides Sub LoadData()
        _anEmployeesUserControl.LoadSupportingData()
        _anEmployeesUserControl.LoadData()
        _anOrdersUserControl.LoadSupportingData()
    End Sub

#Region "private Fields"
    Private _anEmployeesUserControl As EmployeesUserControl
    Private _anOrdersUserControl As OrdersUserControl
    Private _ordersForCurrentEmployee As New ObservableCollection(Of Order)()
#End Region ' private Fields

End Class