﻿Imports System.Text
Imports Microsoft.Windows.Controls

Imports DomainModel
Imports IdeaBlade.EntityModel
Imports System.Collections.ObjectModel

''' <summary>
''' Interaction logic for OrdersUserControl.xaml
''' </summary>
Partial Public Class OrdersUserControl
    Public Sub New()
        Me.InitializeComponent()
        ConfigureOrderSelectorListBox()
    End Sub

    Private Sub ConfigureOrderSelectorListBox()
        '_selectOrderListBox.DisplayMemberPath = Order.PathFor(e => e.CompanyName);
    End Sub

    Public Sub LoadData()
        LoadSupportingData()
        LoadMainData()
    End Sub

    Public Sub LoadSupportingData()
        _customers = New ObservableCollection(Of Customer)(_mgr.Customers.OrderBy(Function(c) c.CompanyName))
        ConfigureDataGridComboBoxColumnForCustomer()
    End Sub

    Private Sub ConfigureDataGridComboBoxColumnForCustomer()
        'DataGridComboBoxColumn dgCbCol = (DataGridComboBoxColumn)_ordersDataGrid.Columns[_indexOfCustomerColumn];
        'dgCbCol.ItemsSource = _customers;
        'dgCbCol.DisplayMemberPath = Customer.PathFor(c => c.CompanyName);

        CustomerColumn.ItemsSource = _customers
        CustomerColumn.DisplayMemberPath = Customer.PathFor(Function(c) c.CompanyName)
    End Sub

    Public Sub LoadMainData()
        _orders = New ObservableCollection(Of Order)(_mgr.Orders.OrderBy(Function(o) o.OrderDate))
        '_selectOrderListBox.ItemsSource = _Orders;
        Me.DataContext = _orders
        Me._ordersDataGrid.ItemsSource = _orders
    End Sub

    Public Sub LoadMainData(ByVal orders As ObservableCollection(Of Order))
        _orders.Clear()
        For Each anOrder As Order In orders
            _orders.Add(anOrder)
        Next anOrder
        Me.DataContext = _orders
        Me._ordersDataGrid.ItemsSource = _orders
    End Sub

#Region "Private Fields"
    Private _mgr As New NorthwindIBEntities()
    Private _orders As New ObservableCollection(Of Order)()
    Private _customers As ObservableCollection(Of Customer)
    Private Const _indexOfCustomerColumn As Integer = 1
#End Region ' Private Fields
End Class